<?php

$checker_success = true;

function error($message) {
    return "<strong class='error'><i class='fa fa-bomb' aria-hidden='true'></i>{$message}</strong>";
}

function warning($message) {
    return "<strong class='warning'><i class='fa fa-exclamation-circle' aria-hidden='true'></i>{$message}</strong>";
}

function success($message) {
    return "<strong class='success'><i class='fa fa-check-circle' aria-hidden='true'></i>{$message}</strong>";
}

?>
    <html>
    <head>
        <title>Wasabi Theme server requirements checker</title>
        <meta name="robots" content="noindex,follow">
        <link href="https://fonts.googleapis.com/css?family=Lato%3Aregular%7CRaleway%3A600&subset=latin%2Clatin-ext&display=swap&ver=0.1" rel="stylesheet">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css">
        <style type="text/css">
            * {
                box-sizing: border-box;
            }

            html, body {
                width: 100%;
                height: 100%;
            }

            html {
                display: table;
            }

            body {
                display: table-cell;
                vertical-align: middle;
                background: #333;
                color: #444;
                font-family: 'Lato', sans-serif;
            }

            .container {
                max-width: 550px;
                width: 100%;
                margin: auto;
            }

            table {
                width: 100%;
                margin-top: 1.5em;
                background-color: #fff;
                border-radius: 4px;
                border-collapse: collapse;
            }

            table th, table td {
                padding: 0.8em 1em;
            }

            table tr {
                border-bottom: 1px solid #bbb;
            }

            table tr:last-child {
                border: none;
            }

            table td > strong {
                color: #444 !important;
            }

            table td small {
                font-weight: 400;
                clear: both;
                width: 100%;
                display: block;
                font-size: 0.8em;
                margin-top: 0.2em;
            }

            table td i {
                margin-right: 0.2em;
            }

            h1, h2 {
                font-family: 'Raleway', sans-serif;
                margin: 0;
                text-align: center;
                font-size: 40px;
                color: #7BC552;
            }

            svg {
                max-width: 100%;
            }

            .result {
                margin-top: 1.5em;
                text-align: center;
                font-weight: bold;
                font-size: 1.2em;
            }

            .success, .success i {
                color: #7BC552;
            }

            .error, .error i {
                color: #c9282e;
            }

            .warning, .warning i {
                color: #fdcc0d;
            }
        </style>
    </head>
    <body>
    <div class="container">
        <svg xmlns="http://www.w3.org/2000/svg" width="815.5" height="130.4" fill-rule="evenodd" clip-rule="evenodd" image-rendering="optimizeQuality" shape-rendering="geometricPrecision" text-rendering="geometricPrecision" viewBox="0 0 20681 3306.9">
            <defs/>
            <g transform="translate(-1166.6 -923.3)">
                <path fill="#bbb" fill-rule="nonzero" d="M3755 1272c74 53 143 111 208 175 291 292 471 695 471 1140s-180 847-471 1139c-292 291-695 472-1140 472s-847-181-1139-472c-291-292-472-694-472-1139s181-848 472-1140c50-49 102-95 158-138l176 550 3 9c31 97 56 176 64 199l245 739 42 124 219-706 82-265h265c1 0 3 9 8 26l209 672 83 273c3 0 16-36 40-109l240-730 75-256 1-1zm205 431l-313 980-230 669-31 93h-298c-2 0-7-15-14-44-44-137-86-271-126-400l-140-456h-2l-211 675-70 225h-299c-1 0-10-28-28-82l-220-642-236-686-95-278c-166 235-263 521-263 830 0 397 161 757 422 1017 260 261 620 422 1017 422 398 0 758-161 1018-422 261-260 422-620 422-1017 0-333-113-640-303-884zm950 393c1 0 13 34 35 103l233 702 40 117 208-670 78-252h252c1 0 3 8 7 25l199 638 80 259c2 0 14-34 37-103l228-694 43-125h314v1l-234 687-219 635-29 89h-283c-2 0-7-14-13-41-43-131-82-258-120-381l-134-433h-1l-201 641-66 214h-285c-1 0-9-26-26-78l-210-610-224-652-23-72zm2687-23c164 0 305 63 421 188v-162l5-3h279l2 3v1406l-2 3h-279l-5-3v-143c-110 121-251 181-424 181h-2c-215 0-398-87-548-260-112-141-168-299-168-474v-1c0-216 84-403 251-560 138-116 295-175 470-175zm-436 735c0 155 67 282 200 381 75 46 145 68 212 68h33c94 0 186-38 274-115 92-94 138-205 138-333v-1c0-157-66-284-200-380-74-46-146-68-218-68h-24c-118 0-224 54-320 163-64 91-95 185-95 285zm2100-793c180 0 333 56 459 168 28 27 48 49 60 65l18 28c-2 3-29 19-80 50-50 30-104 64-160 102-18-22-36-40-54-52-66-50-146-75-240-75h-6c-103 0-185 24-247 73-35 30-52 62-52 96 0 22 9 39 28 50 19 16 55 33 109 52 75 24 191 50 348 78 51 12 95 26 131 41 34 14 69 33 103 56 16 11 38 31 67 59 71 79 107 167 107 266v4c0 100-37 194-112 282-31 32-54 52-68 60-39 28-71 47-97 57-100 47-207 70-320 70h-10c-147 0-282-39-404-117-27-17-55-40-85-69-29-28-49-49-59-65-20-25-37-50-52-76l246-142h1l13 21c10 16 28 36 51 59 44 41 99 70 165 88 44 10 86 15 130 15 86 0 164-19 231-57 13-8 29-20 47-38 26-30 39-61 39-91 0-54-42-97-126-128-27-10-78-21-151-33-159-30-276-62-354-95-34-14-66-32-99-53-74-49-124-110-147-185-12-33-18-68-18-106v-9c0-93 35-181 105-262 29-30 51-50 63-59 33-25 65-44 95-59 98-46 206-69 325-69zm1570 58c164 0 305 63 422 188v-162l4-3h279l3 3v1406l-3 3h-279l-4-3v-143c-110 121-252 181-425 181h-1c-215 0-398-87-548-260-113-141-168-299-168-474v-1c0-216 83-403 250-560 138-116 295-175 470-175zm-436 735c0 155 67 282 200 381 75 46 145 68 212 68h33c94 0 186-38 274-115 92-94 139-205 139-333v-1c0-157-67-284-201-380-74-46-146-68-218-68h-24c-117 0-224 54-320 163-63 91-95 185-95 285zm1875-2v8c0 96 29 185 87 266 13 18 31 39 54 62l27 24c31 23 58 41 81 52 60 27 119 41 178 41 120 0 225-46 313-139 33-39 59-77 75-113 28-63 43-128 43-195v-6c0-111-37-211-111-300-88-99-197-148-324-148-57 0-119 16-184 48-30 14-59 35-89 61-27 27-44 45-51 55-66 83-99 178-99 284zm-283-1456h282l1 1v911h2c14-19 34-40 60-60a569 569 0 01367-129h1c160 0 306 52 438 155 18 14 44 38 78 73 68 77 117 155 146 234 35 88 52 180 52 274 0 125-30 245-92 358-19 38-47 79-82 123-39 43-69 74-93 93-28 21-53 39-77 52-116 72-237 108-364 108h-19c-52 0-116-10-190-31-37-13-71-28-100-45-23-14-49-34-79-58l-48-48v147h-285V1351zm2091 746v1410l-1 2h-283l-1-2V2096z" class="fil0"/>
                <ellipse cx="13923" cy="1810" fill="#7bc552" rx="177" ry="176"/>
                <path fill="#7bc552" fill-rule="nonzero" d="M2823 976c218 0 426 43 616 121l26-65 125 236-242 53 26-64c-169-71-355-110-551-110-290 0-559 86-785 234l-55-169c245-150 533-236 840-236z"/>
                <path fill="#bbb" fill-rule="nonzero" d="M15078 2294v-133h-311v-587h-133v587h-181v133h181v1206h133V2294zm1384 1209v-820c0-361-176-542-528-542-186 0-319 66-399 198V1101h-133v2399h133v-872c0-108 40-195 120-260 78-64 171-97 279-97 264 0 395 142 395 425v807zm1673-700c0-197-66-357-198-480-129-123-294-185-492-185-201 0-368 66-500 198-129 130-194 295-194 496 0 199 66 364 198 496 129 132 295 198 496 198 84 0 160-11 227-33 175-56 304-164 389-324l-120-55c-74 119-157 198-250 237-73 30-156 45-246 45-178 0-317-54-419-162-97-106-145-250-145-431zm-149-127h-1086c86-272 268-408 545-408 131 0 248 37 350 110 106 76 169 175 191 298zm2114 824v-924c0-136-41-243-124-321-82-76-190-114-324-114-175 0-301 71-379 211-82-140-210-211-383-211-144 0-249 51-314 153v-133h-133v1339h133v-924c0-93 30-167 91-221 60-56 135-84 223-84 87 0 161 29 224 88 61 54 91 126 91 217v924h133v-924c0-203 105-305 314-305 102 0 180 30 234 91 54 60 81 132 81 214v924zm1708-697c0-197-66-357-198-480-129-123-294-185-492-185-201 0-368 66-500 198-129 130-194 295-194 496 0 199 66 364 198 496 129 132 295 198 496 198 84 0 160-11 227-33 175-56 304-164 389-324l-120-55c-74 119-157 198-250 237-74 30-156 45-246 45-178 0-317-54-419-162-97-106-145-250-145-431zm-149-127h-1086c86-272 268-408 545-408 131 0 248 37 350 110 106 76 169 175 191 298z"/>
                <path fill="none" d="M0 0h22886v4991H0z"/>
            </g>
        </svg>

        <h1>Server requirements</h1>

        <table>
            <tbody>
            <tr>
                <th>PHP</th>
                <td>
                    <?php
                    if (version_compare(phpversion(), '7.2', '<')) :
                        echo error(phpversion().' <small>PHP version equal to or greater than 7.2 required</small>');
                        $checker_success = false;
                    elseif (version_compare(phpversion(), '7.2', '>=') && version_compare(phpversion(), '7.4', '<')) :
                        echo warning(phpversion().' <small>PHP version equal or greater than 7.4 recommended</small>');
                    else:
                        echo success(phpversion());
                    endif;
                    ?>
                </td>
            </tr>
            <?php foreach (['mbstring', 'curl', 'dom', 'json', 'iconv', 'libxml'] as $extension): ?>
                <tr>
                    <th>PHP extension: <?php echo $extension; ?></th>
                    <td>
                        <?php
                        if (extension_loaded($extension)) {
                            echo success('Enabled');
                        } else {
                            echo error('Disabled');
                            $checker_success = false;
                        }
                        ?>
                    </td>
                </tr>
            <?php endforeach; ?>
            </tbody>
        </table>
        <p class="result<?php echo $checker_success ? ' success' : ' error' ?>">
            <?php
            if($checker_success){
                echo success('Your server is ready to run Wasabi!');
            } else {
                echo error('Your server does not meet some requirements for running Wasabi. Please contact your hosting provider to activate the missing dependencies.');
            }
            ?>
        </p>
    </div>
    </body>
    </html>
<?php
